# -*- coding: utf-8 -*-
"""
Created on Mon Apr 18 02:26:28 2016

@author: david
"""

import csv
from numpy import *
from matplotlib.pyplot import *
from scipy.interpolate import *





data=loadtxt(open("response05.txt","rb"))

# phase=distance/wavelength
# phase=distance*frequency/speed
# phase=distance/(period*speed)
# phase=0.5/(340*period/16*us)=23529/period


# -1 period 0 data
# 2*period/52
# 2*195=390/13*4


level=127
accumulated=0.0

i=0

p=empty(0)
pp=empty(0)
ppi=empty(0)
tp=empty(0)
idealphase=empty(0)

for j in range(139):
    start=i+3
    period=int(data[i+1])
    cycles=(2*period)/(13*4)
    i=start+1;
    minv=level;
    array=zeros(period*2)
    nc=zeros(period*2)
    k=0
    while(data[i]!=-1 and i<data.shape[0]):
        if(data[i]<minv):
            minv=data[i]
        array[(k*13*4)%(period*2)]=array[(k*13*4)%(period*2)]+data[i]
        nc[(k*13*4)%(period*2)]=nc[(k*13*4)%(period*2)]+1
        k=k+1     
        i=i+1

    if(period<180 or period>220):
        continue
        
    count=0
    for k in range(period*2):
        if(nc[k]!=0):
            array[k]=array[k]/nc[k]
            count=count+1
            
    signal=zeros(count)
    time=zeros(count)
    m=0
    minv=level
    for k in range(period*2):
        if(nc[k]!=0):
            signal[m]=array[k]    
            time[m]=k
            if(signal[m]<minv):
                minv=signal[m]
                
            if (m>0 and signal[m]>level and signal[m-1]<=level):
                tx=-(k-(time[m]-time[m-1])*(signal[m]-level)/(signal[m]-signal[m-1]))
                
            m=m+1


    p=append(p,minv)
    tt=tx/(2.0*period)+accumulated
    if(tp.shape[0]>0 and tt>tp[-1]+0.05):
        accumulated=accumulated-1.0
        tt=tt-1.0
    tp=append(tp,tt)
    pp=append(pp,period)
    ppi=append(ppi,1.0/period)
    idealphase=append(idealphase,18823.0/(2*period)-54.0)

    fig=figure()
    fig.suptitle(str(period))
    plot(time,signal,"or")   


figure()
plot(pp,p)

figure()
plot(pp,tp)

plot(pp,idealphase)

figure()
plot(pp,tp-idealphase)